'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _IconCheck = require('./IconCheck');

var _IconCheck2 = _interopRequireDefault(_IconCheck);

var _styledComponents = require('./styled-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function Checkbox(_ref) {
  var value = _ref.value,
      size = _ref.size,
      kind = _ref.kind,
      render = _ref.render,
      otherProps = _objectWithoutProperties(_ref, ['value', 'size', 'kind', 'render']);

  var child = render && render(value);

  return React.createElement(
    _styledComponents.Container,
    Object.assign({ checked: !!child, size: size, kind: kind }, otherProps),
    React.createElement(
      _styledComponents.Content,
      { checked: !!child },
      child
    )
  );
}
Checkbox.defaultProps = {
  size: 14,
  kind: 'primary',
  render: function render(value) {
    return value ? React.createElement(_IconCheck2.default, { width: 8, height: 8 }) : null;
  }
};
Checkbox.propTypes = {
  value: _propTypes2.default.any,
  size: _propTypes2.default.number,
  kind: _propTypes2.default.string,
  render: _propTypes2.default.func // (value: any) => React.Node,
};

exports.default = Checkbox;
module.exports = exports['default'];