'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _light = require('react-syntax-highlighter/dist/light');

var _light2 = _interopRequireDefault(_light);

var _javascript = require('highlight.js/lib/languages/javascript');

var _javascript2 = _interopRequireDefault(_javascript);

var _cpp = require('highlight.js/lib/languages/cpp');

var _cpp2 = _interopRequireDefault(_cpp);

var _arduino = require('highlight.js/lib/languages/arduino');

var _arduino2 = _interopRequireDefault(_arduino);

var _githubGist = require('react-syntax-highlighter/styles/hljs/github-gist');

var _githubGist2 = _interopRequireDefault(_githubGist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

(0, _light.registerLanguage)('javascript', _javascript2.default);
(0, _light.registerLanguage)('cpp', _cpp2.default); // Remind: for arduino
(0, _light.registerLanguage)('arduino', _arduino2.default);

var Code = (0, _styledComponents.withTheme)(function (_ref) {
  var style = _ref.style,
      theme = _ref.theme,
      otherProps = _objectWithoutProperties(_ref, ['style', 'theme']);

  return _react2.default.createElement(_light2.default, Object.assign({
    style: _githubGist2.default,
    customStyle: _extends({
      backgroundColor: 'initial',
      margin: 0,
      padding: 0,
      fontSize: theme.fontSize.small
    }, style),
    wrapLines: true
  }, otherProps));
});

Code.displayName = 'Code';
Code.propTypes = {
  language: _propTypes2.default.oneOf(['javascript', 'cpp', 'arduino']),
  style: _propTypes2.default.object
};
Code.defaultProps = {
  language: 'javascript'
};

exports.default = Code;
module.exports = exports['default'];