'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStatusStream = exports.StyledButton = undefined;

var _IconDone2 = require('mcs-lite-icon/lib/IconDone');

var _IconDone3 = _interopRequireDefault(_IconDone2);

var _IconLoading2 = require('mcs-lite-icon/lib/IconLoading');

var _IconLoading3 = _interopRequireDefault(_IconLoading2);

var _omit2 = require('ramda/src/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _templateObject = _taggedTemplateLiteral(['width:42px;> div{transform-origin:center center;animation:', ';}path{fill:currentColor;}'], ['width:42px;> div{transform-origin:center center;animation:', ';}path{fill:currentColor;}']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _componentFromStream = require('recompose/componentFromStream');

var _createEventHandler2 = require('recompose/createEventHandler');

var _copyToClipboard = require('copy-to-clipboard');

var _copyToClipboard2 = _interopRequireDefault(_copyToClipboard);

var _MorphReplace = require('react-svg-morph/lib/MorphReplace');

var _MorphReplace2 = _interopRequireDefault(_MorphReplace);

var _Observable = require('rxjs/Observable');

var _async = require('rxjs/scheduler/async');

require('rxjs/add/operator/combineLatest');

require('rxjs/add/operator/withLatestFrom');

require('rxjs/add/observable/of');

require('rxjs/add/operator/switchMapTo');

require('rxjs/add/operator/delay');

require('rxjs/add/operator/merge');

require('rxjs/add/operator/startWith');

require('rxjs/add/operator/pluck');

require('rxjs/add/observable/from');

require('rxjs/add/observable/merge');

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _rotate = require('../Spin/rotate360');

var _rotate2 = _interopRequireDefault(_rotate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var DEFAULT = 'default';
var LOADING = 'loading';
var SUCCESS = 'success';

var StyledButton = exports.StyledButton = (0, _styledComponents2.default)(_Button2.default)(_templateObject, function (props) {
  return props.status === LOADING ? _rotate2.default + ' 0.6s infinite cubic-bezier(0.41, 0.01, 0.58, 1)' : 'none';
});

var getStatusStream = exports.getStatusStream = function getStatusStream(source$) {
  var t1 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;
  var t2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1800;
  var scheduler = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _async.async;
  return source$.switchMapTo(_Observable.Observable.merge(_Observable.Observable.of(LOADING), _Observable.Observable.of(SUCCESS).delay(t1, scheduler), _Observable.Observable.of(DEFAULT).delay(t2, scheduler))).startWith(DEFAULT);
};

var omitProps = (0, _omit3.default)(['text']);

var componentFromStream = (0, _componentFromStream.componentFromStreamWithConfig)({
  fromESObservable: _Observable.Observable.from,
  toESObservable: function toESObservable(stream) {
    return stream;
  }
});
var createEventHandler = (0, _createEventHandler2.createEventHandlerWithConfig)({
  fromESObservable: _Observable.Observable.from,
  toESObservable: function toESObservable(stream) {
    return stream;
  }
});

var CopyButton = componentFromStream(function (props$) {
  var _createEventHandler = createEventHandler(),
      onClick = _createEventHandler.handler,
      onClick$ = _createEventHandler.stream;

  var text$ = props$.pluck('text');
  var status$ = getStatusStream(onClick$);

  // Remind: copyToClipboard Side-effects
  onClick$.withLatestFrom(text$, function (status, text) {
    return text;
  }).subscribe(_copyToClipboard2.default);

  return props$.combineLatest(status$, function (_ref, status) {
    var children = _ref.children,
        otherProps = _objectWithoutProperties(_ref, ['children']);

    return _react2.default.createElement(
      StyledButton,
      Object.assign({}, omitProps(otherProps), {
        size: 'small',
        status: status,
        onClick: onClick
      }),
      _react2.default.createElement(
        'div',
        null,
        status === DEFAULT ? children : _react2.default.createElement(
          _MorphReplace2.default,
          { width: 10, height: 10 },
          status === LOADING ? _react2.default.createElement(_IconLoading3.default, { key: 'loading' }) : _react2.default.createElement(_IconDone3.default, { key: 'success' })
        )
      )
    );
  });
});

CopyButton.displayName = 'CopyButton';
CopyButton.propTypes = {
  text: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired
};

exports.default = CopyButton;