'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputWrapper = exports.Value = exports.ValueWrapper = exports.LabelItem = exports.LabelWrapper = exports.Container = undefined;

var _identity2 = require('ramda/src/identity');

var _identity3 = _interopRequireDefault(_identity2);

var _templateObject = _taggedTemplateLiteral(['width:100%;display:flex;flex-direction:column-reverse;'], ['width:100%;display:flex;flex-direction:column-reverse;']),
    _templateObject2 = _taggedTemplateLiteral(['display:flex;> *:first-child{align-items:', ';}> *:last-child{align-items:', ';}'], ['display:flex;> *:first-child{align-items:', ';}> *:last-child{align-items:', ';}']),
    _templateObject3 = _taggedTemplateLiteral(['display:flex;align-items:center;flex-direction:column;margin:0 4px;flex-grow:1;flex-basis:0;overflow:hidden;&::before{content:\'\';border-right-width:1px;border-right-style:solid;border-right-color:', ';height:4px;margin-top:5px;margin-bottom:8px;}'], ['display:flex;align-items:center;flex-direction:column;margin:0 4px;flex-grow:1;flex-basis:0;overflow:hidden;&::before{content:\'\';border-right-width:1px;border-right-style:solid;border-right-color:', ';height:4px;margin-top:5px;margin-bottom:8px;}']),
    _templateObject4 = _taggedTemplateLiteral(['\n  margin-bottom: 15px;\n'], ['\n  margin-bottom: 15px;\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  display: inline-block;\n'], ['\n  display: inline-block;\n']),
    _templateObject6 = _taggedTemplateLiteral(['padding:0 ', ';'], ['padding:0 ', ';']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _InputRange = require('../InputRange');

var _InputRange2 = _interopRequireDefault(_InputRange);

var _P = require('../P');

var _P2 = _interopRequireDefault(_P);

var _isNumber = require('../utils/isNumber');

var _isNumber2 = _interopRequireDefault(_isNumber);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Container = exports.Container = _styledComponents2.default.div(_templateObject);

var LabelWrapper = exports.LabelWrapper = _styledComponents2.default.div(_templateObject2, function (props) {
  return props.labels.length <= 2 ? 'flex-start' : 'center';
}, function (props) {
  return props.labels.length <= 2 ? 'flex-end' : 'center';
});

var LabelItem = exports.LabelItem = _styledComponents2.default.div(_templateObject3, function (props) {
  return props.theme.color.grayBase;
});

var ValueWrapper = exports.ValueWrapper = _P2.default.extend(_templateObject4);

var Value = exports.Value = _P2.default.extend(_templateObject5);

var InputWrapper = exports.InputWrapper = _styledComponents2.default.div(_templateObject6, function (props) {
  return (props.labels.length <= 2 ? 0 : 100 / props.labels.length / 2 - 3) + '%';
});

var ControlRange = function ControlRange(_ref) {
  var value = _ref.value,
      onChange = _ref.onChange,
      onSubmit = _ref.onSubmit,
      labels = _ref.labels,
      valueMapper = _ref.valueMapper,
      otherProps = _objectWithoutProperties(_ref, ['value', 'onChange', 'onSubmit', 'labels', 'valueMapper']);

  var min = (0, _isNumber2.default)(labels[0]) ? labels[0] : 0;
  var max = (0, _isNumber2.default)(labels[1]) ? labels[1] : labels.length - 1;

  return _react2.default.createElement(
    Container,
    otherProps,
    _react2.default.createElement(
      LabelWrapper,
      { labels: labels },
      labels.map(function (e) {
        return _react2.default.createElement(
          LabelItem,
          { key: e },
          _react2.default.createElement(
            _P2.default,
            { color: 'grayDark' },
            e
          )
        );
      })
    ),
    _react2.default.createElement(
      InputWrapper,
      { labels: labels },
      _react2.default.createElement(
        ValueWrapper,
        { color: 'grayDark' },
        'Current value:\xA0',
        _react2.default.createElement(
          Value,
          { color: 'primary' },
          valueMapper(value)
        )
      ),
      _react2.default.createElement(_InputRange2.default, {
        min: min,
        max: max,
        step: 1,
        value: value,
        onChange: onChange,
        onMouseUp: onSubmit // for desktop
        , onTouchEnd: onSubmit // for mobile
      })
    )
  );
};

ControlRange.displayName = 'ControlRange';
ControlRange.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), // index of labels
  onChange: _propTypes2.default.func.isRequired,
  onSubmit: _propTypes2.default.func.isRequired,
  valueMapper: _propTypes2.default.func, // index: number => value: string
  labels: _propTypes2.default.array.isRequired
};

ControlRange.defaultProps = {
  valueMapper: _identity3.default
};

exports.default = ControlRange;