'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledTextarea = exports.ButtonWrapper = exports.Container = undefined;

var _templateObject = _taggedTemplateLiteral(['width:100%;display:flex;flex-direction:column;align-self:stretch;'], ['width:100%;display:flex;flex-direction:column;align-self:stretch;']),
    _templateObject2 = _taggedTemplateLiteral(['display:flex;justify-content:space-between;align-items:center;flex-wrap:wrap;margin-top:10px;flex-shrink:0;'], ['display:flex;justify-content:space-between;align-items:center;flex-wrap:wrap;margin-top:10px;flex-shrink:0;']),
    _templateObject3 = _taggedTemplateLiteral(['height:100%;min-height:4em;flex-grow:1;'], ['height:100%;min-height:4em;flex-grow:1;']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _ButtonClear = require('./ButtonClear');

var _ButtonClear2 = _interopRequireDefault(_ButtonClear);

var _Textarea = require('../Textarea');

var _Textarea2 = _interopRequireDefault(_Textarea);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Container = exports.Container = _styledComponents2.default.div(_templateObject);

var ButtonWrapper = exports.ButtonWrapper = _styledComponents2.default.div(_templateObject2);

var StyledTextarea = exports.StyledTextarea = (0, _styledComponents2.default)(_Textarea2.default)(_templateObject3);

var ControlString = function ControlString(_ref) {
  var value = _ref.value,
      onChange = _ref.onChange,
      onSubmit = _ref.onSubmit,
      onClear = _ref.onClear,
      placeholder = _ref.placeholder,
      otherProps = _objectWithoutProperties(_ref, ['value', 'onChange', 'onSubmit', 'onClear', 'placeholder']);

  return _react2.default.createElement(
    Container,
    otherProps,
    _react2.default.createElement(StyledTextarea, {
      value: value,
      onChange: onChange,
      placeholder: placeholder
    }),
    _react2.default.createElement(
      ButtonWrapper,
      null,
      _react2.default.createElement(_ButtonClear2.default, { onClick: onClear }),
      _react2.default.createElement(
        _Button2.default,
        { onClick: onSubmit },
        'Ok'
      )
    )
  );
};

ControlString.displayName = 'ControlString';
ControlString.propTypes = {
  value: _propTypes2.default.string.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  onSubmit: _propTypes2.default.func.isRequired,
  onClear: _propTypes2.default.func.isRequired,
  placeholder: _propTypes2.default.string
};

exports.default = ControlString;