'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _T2 = require('ramda/src/T');

var _T3 = _interopRequireDefault(_T2);

var _isEmpty2 = require('ramda/src/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _pluck2 = require('ramda/src/pluck');

var _pluck3 = _interopRequireDefault(_pluck2);

var _propEq2 = require('ramda/src/propEq');

var _propEq3 = _interopRequireDefault(_propEq2);

var _findIndex2 = require('ramda/src/findIndex');

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _isNil2 = require('ramda/src/isNil');

var _isNil3 = _interopRequireDefault(_isNil2);

var _equals2 = require('ramda/src/equals');

var _equals3 = _interopRequireDefault(_equals2);

var _cond2 = require('ramda/src/cond');

var _cond3 = _interopRequireDefault(_cond2);

var _defaultTo2 = require('ramda/src/defaultTo');

var _defaultTo3 = _interopRequireDefault(_defaultTo2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['width:100%;'], ['width:100%;']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _DataChannel = require('../DataChannel');

var _DataChannel2 = _interopRequireDefault(_DataChannel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // @type


var Wrapper = _styledComponents2.default.div(_templateObject);

/**
 * type DCEvent = {
 *   id: string,
 *   values: {
 *     value?: string | number,
 *     period?: number,
 *   },
 *   type: 'SUBMIT' | 'CHANGE' | 'CLEAR',
 * };
 * type DCEventHandler = DCEvent => void
 */

var NO_DATA_PLACEHOLDER = 'N/A';

var DataChannelAdapter = function (_React$Component) {
  _inherits(DataChannelAdapter, _React$Component);

  function DataChannelAdapter() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DataChannelAdapter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DataChannelAdapter.__proto__ || Object.getPrototypeOf(DataChannelAdapter)).call.apply(_ref, [this].concat(args))), _this), _this.switchByType = function () {
      var _this$props = _this.props,
          dataChannelProps = _this$props.dataChannelProps,
          eventHandler = _this$props.eventHandler;
      var id = dataChannelProps.id,
          type = dataChannelProps.type,
          format = dataChannelProps.format;

      // Remind: API response could be 'null' value.

      var values = (0, _defaultTo3.default)({})(dataChannelProps.values);

      return (0, _cond3.default)([
      /**
       * Switch
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('SWITCH_CONTROL'), function () {
        return _react2.default.createElement(_DataChannel2.default.ControlSwitch, {
          value: Boolean(values.value),
          onSubmit: function onSubmit() {
            return eventHandler({
              type: 'SUBMIT',
              id: id,
              values: { value: !values.value ? 1 : 0 }
            });
          }
        });
      }], [(0, _equals3.default)('SWITCH_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayStatus, {
          value: values.value && values.value ? 1 : 0,
          labels: ['OFF', 'ON']
        });
      }],

      /**
       * Integer
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('INTEGER_CONTROL'), function () {
        return _react2.default.createElement(_DataChannel2.default.ControlNumber, {
          placeholder: 'Integer only',
          unit: format.unit && '\u55AE\u4F4D\uFF1A' + format.unit,
          value: (0, _isNil3.default)(values.value) ? '' : parseInt(values.value, 10),
          onSubmit: function onSubmit() {
            return eventHandler({ type: 'SUBMIT', id: id, values: values });
          },
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: e.target.value }
            });
          },
          onClear: function onClear() {
            return eventHandler({ type: 'CLEAR', id: id, values: {} });
          }
        });
      }], [(0, _equals3.default)('INTEGER_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayUnitValue, {
          value: (0, _isNil3.default)(values.value) ? NO_DATA_PLACEHOLDER : parseInt(values.value, 10),
          unit: format.unit
        });
      }],

      /**
       * Float
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('FLOAT_CONTROL'), function () {
        return _react2.default.createElement(_DataChannel2.default.ControlNumber, {
          placeholder: 'Float only',
          unit: format.unit && '\u55AE\u4F4D\uFF1A' + format.unit,
          value: (0, _isNil3.default)(values.value) ? '' : parseFloat(values.value, 10),
          onSubmit: function onSubmit() {
            return eventHandler({ type: 'SUBMIT', id: id, values: values });
          },
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: e.target.value }
            });
          },
          onClear: function onClear() {
            return eventHandler({ type: 'CLEAR', id: id, values: {} });
          }
        });
      }], [(0, _equals3.default)('FLOAT_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayUnitValue, {
          value: (0, _isNil3.default)(values.value) ? NO_DATA_PLACEHOLDER : parseFloat(values.value, 10),
          unit: format.unit
        });
      }],

      /**
       * String
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('STRING_CONTROL'), function () {
        return _react2.default.createElement(_DataChannel2.default.ControlString, {
          placeholder: 'String only',
          value: (0, _isNil3.default)(values.value) ? '' : values.value,
          onSubmit: function onSubmit() {
            return eventHandler({ type: 'SUBMIT', id: id, values: values });
          },
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: e.target.value }
            });
          },
          onClear: function onClear() {
            return eventHandler({ type: 'CLEAR', id: id, values: {} });
          }
        });
      }], [(0, _equals3.default)('STRING_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayString, {
          placeholder: 'String only',
          value: (0, _isNil3.default)(values.value) ? '' : values.value
        });
      }],

      /**
       * HEX
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('HEX_CONTROL'), function () {
        return _react2.default.createElement(_DataChannel2.default.ControlString, {
          placeholder: 'Hex only',
          value: (0, _isNil3.default)(values.value) ? '' : values.value,
          onSubmit: function onSubmit() {
            return eventHandler({ type: 'SUBMIT', id: id, values: values });
          },
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: e.target.value }
            });
          },
          onClear: function onClear() {
            return eventHandler({ type: 'CLEAR', id: id, values: {} });
          }
        });
      }], [(0, _equals3.default)('HEX_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayString, {
          placeholder: 'Hex only',
          value: (0, _isNil3.default)(values.value) ? '' : values.value
        });
      }],

      /**
       * GPIO
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('GPIO_CONTROL'), function () {
        var labels = ['Low', 'High'];
        var valueMapper = function valueMapper(index) {
          return labels[index] || NO_DATA_PLACEHOLDER;
        };

        return _react2.default.createElement(_DataChannel2.default.ControlRange, {
          value: (0, _isNil3.default)(values.value) ? '' : values.value,
          labels: labels,
          valueMapper: valueMapper,
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: e.target.value }
            });
          },
          onSubmit: function onSubmit() {
            return eventHandler({
              type: 'SUBMIT',
              id: id,
              values: { value: values.value }
            });
          }
        });
      }], [(0, _equals3.default)('GPIO_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayStatus, {
          value: (0, _isNil3.default)(values.value) ? undefined : values.value,
          labels: ['Low', 'High']
        });
      }],

      /**
       * Category
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('CATEGORY_CONTROL'), function () {
        var value = (0, _isNil3.default)(values.value) ? undefined : (0, _findIndex3.default)((0, _propEq3.default)('value', values.value))(format.items);
        var valueMapper = function valueMapper(index) {
          return format.items[index] ? format.items[index].value : NO_DATA_PLACEHOLDER;
        };

        return _react2.default.createElement(_DataChannel2.default.ControlRange, {
          value: value,
          labels: (0, _pluck3.default)('name')(format.items),
          valueMapper: valueMapper,
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: valueMapper(e.target.value) }
            });
          },
          onSubmit: function onSubmit() {
            return eventHandler({
              type: 'SUBMIT',
              id: id,
              values: { value: values.value }
            });
          }
        });
      }], [(0, _equals3.default)('CATEGORY_DISPLAY'), function () {
        var value = (0, _isNil3.default)(values.value) ? undefined : (0, _findIndex3.default)((0, _propEq3.default)('value', values.value))(format.items);

        return _react2.default.createElement(_DataChannel2.default.DisplayStatus, {
          value: value,
          labels: (0, _pluck3.default)('name')(format.items)
        });
      }],

      /**
       * Analog (Control only)
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('ANALOG_CONTROL'), function () {
        // Hint: index could be empty string. (For Controlled Component usage.)
        var valueMapper = function valueMapper(index) {
          return (0, _isNil3.default)(index) || (0, _isEmpty3.default)(index) ? NO_DATA_PLACEHOLDER : index;
        };

        return _react2.default.createElement(_DataChannel2.default.ControlRange, {
          value: (0, _isNil3.default)(values.value) ? '' : values.value,
          valueMapper: valueMapper,
          labels: [parseFloat(format.lowerbound, 10), parseFloat(format.upperbound, 10)],
          onChange: function onChange(e) {
            return eventHandler({
              type: 'CHANGE',
              id: id,
              values: { value: e.target.value }
            });
          },
          onSubmit: function onSubmit() {
            return eventHandler({
              type: 'SUBMIT',
              id: id,
              values: { value: values.value }
            });
          }
        });
      }],

      /**
       * PWM
       *
       * @author Michael Hsu
       */

      [(0, _equals3.default)('PWM_DISPLAY'), function () {
        return _react2.default.createElement(_DataChannel2.default.DisplayMultipleValue, {
          items: [{
            name: 'Value',
            value: (0, _isNil3.default)(values.value) ? NO_DATA_PLACEHOLDER : values.value
          }, {
            name: 'Period',
            value: (0, _isNil3.default)(values.period) ? NO_DATA_PLACEHOLDER : values.period
          }]
        });
      }], [(0, _equals3.default)('PWM_CONTROL'), function () {
        // Hint: index could be empty string. (For Controlled Component usage.)
        var valueMapper = function valueMapper(index) {
          return (0, _isNil3.default)(index) || (0, _isEmpty3.default)(index) ? NO_DATA_PLACEHOLDER : index;
        };

        return _react2.default.createElement(
          Wrapper,
          null,
          _react2.default.createElement(_DataChannel2.default.ControlPeriod, {
            value: (0, _isNil3.default)(values.period) ? '' : values.period,
            onSubmit: function onSubmit() {
              return eventHandler({ type: 'SUBMIT', id: id, values: values });
            },
            onChange: function onChange(e) {
              return eventHandler({
                type: 'CHANGE',
                id: id,
                values: { period: e.target.value, value: values.value }
              });
            },
            placeholder: 'Integer only'
          }),
          _react2.default.createElement(_DataChannel2.default.ControlRange, {
            value: (0, _isNil3.default)(values.value) ? '' : parseFloat(values.value, 10),
            valueMapper: valueMapper,
            labels: [parseFloat(format.lowerbound, 10), parseFloat(format.upperbound, 10)],
            onChange: function onChange(e) {
              return eventHandler({
                type: 'CHANGE',
                id: id,
                values: { value: e.target.value, period: values.period }
              });
            },
            onSubmit: function onSubmit() {
              return eventHandler({
                type: 'SUBMIT',
                id: id,
                values: { value: values.value, period: values.period }
              });
            }
          })
        );
      }], [_T3.default, function (name) {
        return _react2.default.createElement(
          'div',
          null,
          name,
          ' NOT SUPPORTED.'
        );
      }]])(type);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // TODO: refactor these handler codes. (maybe hoist)


  _createClass(DataChannelAdapter, [{
    key: 'render',
    value: function render() {
      return this.switchByType();
    }
  }]);

  return DataChannelAdapter;
}(_react2.default.Component);

DataChannelAdapter.propTypes = {
  dataChannelProps: _propTypes2.default.shape({
    id: _propTypes2.default.string.isRequired,
    type: _propTypes2.default.oneOf(['SWITCH_CONTROL', 'SWITCH_DISPLAY', 'INTEGER_CONTROL', 'INTEGER_DISPLAY', 'STRING_CONTROL', 'STRING_DISPLAY', 'HEX_CONTROL', 'HEX_DISPLAY', 'FLOAT_DISPLAY', 'FLOAT_CONTROL', 'GPIO_CONTROL', 'GPIO_DISPLAY', 'CATEGORY_CONTROL', 'CATEGORY_DISPLAY', 'ANALOG_CONTROL', 'PWM_DISPLAY', 'PWM_CONTROL']).isRequired,
    values: _propTypes2.default.shape({
      value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
      period: _propTypes2.default.number
    }),
    format: _propTypes2.default.shape({
      unit: _propTypes2.default.string,
      items: _propTypes2.default.array,
      lowerbound: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
      upperbound: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
    }).isRequired
  }),
  eventHandler: _propTypes2.default.func.isRequired // (event: object) => void
};
exports.default = DataChannelAdapter;
module.exports = exports['default'];