'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledSmall = exports.StyledHeading = exports.Wrapper = exports.StyledHr = exports.Description = exports.Footer = exports.Body = exports.Header = undefined;

var _templateObject = _taggedTemplateLiteral(['flex-basis:24px;align-items:center;justify-content:flex-end;display:flex;'], ['flex-basis:24px;align-items:center;justify-content:flex-end;display:flex;']),
    _templateObject2 = _taggedTemplateLiteral(['flex-grow:1;display:flex;align-items:center;justify-content:center;padding:10px 0;'], ['flex-grow:1;display:flex;align-items:center;justify-content:center;padding:10px 0;']),
    _templateObject3 = _taggedTemplateLiteral(['display:block;'], ['display:block;']),
    _templateObject4 = _taggedTemplateLiteral(['\n  height: ', ';\n'], ['\n  height: ', ';\n']),
    _templateObject5 = _taggedTemplateLiteral(['margin:5px 0;'], ['margin:5px 0;']),
    _templateObject6 = _taggedTemplateLiteral(['\n  height: 300px;\n  padding: 10px 20px;\n  display: flex;\n  flex-direction: column;\n'], ['\n  height: 300px;\n  padding: 10px 20px;\n  display: flex;\n  flex-direction: column;\n']),
    _templateObject7 = _taggedTemplateLiteral(['overflow:hidden;text-overflow:ellipsis;'], ['overflow:hidden;text-overflow:ellipsis;']),
    _templateObject8 = _taggedTemplateLiteral(['display:block;overflow:hidden;text-overflow:ellipsis;color:', ';'], ['display:block;overflow:hidden;text-overflow:ellipsis;color:', ';']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactTextTruncate = require('react-text-truncate');

var _reactTextTruncate2 = _interopRequireDefault(_reactTextTruncate);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _Heading = require('../Heading');

var _Heading2 = _interopRequireDefault(_Heading);

var _Small = require('../Small');

var _Small2 = _interopRequireDefault(_Small);

var _P = require('../P');

var _P2 = _interopRequireDefault(_P);

var _Hr = require('../Hr');

var _Hr2 = _interopRequireDefault(_Hr);

var _isString = require('../utils/isString');

var _isString2 = _interopRequireDefault(_isString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var setHeightByLine = function setHeightByLine(line) {
  return function (props) {
    return parseFloat(props.theme.fontSize.p, 10) * parseFloat(props.theme.base.fontSize, 10) * props.theme.base.lineHeight * line + 'px';
  };
};

var Header = exports.Header = _styledComponents2.default.div(_templateObject);

var Body = exports.Body = _styledComponents2.default.div(_templateObject2);

var Footer = exports.Footer = _styledComponents2.default.div(_templateObject3);

var Description = exports.Description = _P2.default.extend(_templateObject4, setHeightByLine(2));

var StyledHr = exports.StyledHr = (0, _styledComponents2.default)(_Hr2.default)(_templateObject5);

var Wrapper = exports.Wrapper = _Card2.default.extend(_templateObject6);

var StyledHeading = exports.StyledHeading = (0, _styledComponents2.default)(_Heading2.default)(_templateObject7);

var StyledSmall = exports.StyledSmall = (0, _styledComponents2.default)(_Small2.default)(_templateObject8, function (props) {
  return props.theme.color.grayDark;
});

var DataChannelCard = function DataChannelCard(_ref) {
  var header = _ref.header,
      children = _ref.children,
      title = _ref.title,
      subtitle = _ref.subtitle,
      description = _ref.description,
      otherProps = _objectWithoutProperties(_ref, ['header', 'children', 'title', 'subtitle', 'description']);

  return _react2.default.createElement(
    Wrapper,
    otherProps,
    _react2.default.createElement(
      Header,
      null,
      header
    ),
    _react2.default.createElement(
      Body,
      null,
      children
    ),
    _react2.default.createElement(
      Footer,
      null,
      _react2.default.createElement(
        StyledHeading,
        { level: 4 },
        title
      ),
      _react2.default.createElement(
        StyledSmall,
        null,
        subtitle
      ),
      (0, _isString2.default)(description) && _react2.default.createElement(StyledHr, null),
      (0, _isString2.default)(description) && _react2.default.createElement(
        Description,
        null,
        _react2.default.createElement(_reactTextTruncate2.default, { line: 2, truncateText: ' ...', text: description })
      )
    )
  );
};

DataChannelCard.displayName = 'DataChannelCard';
DataChannelCard.propTypes = {
  header: _propTypes2.default.node,
  children: _propTypes2.default.node.isRequired,
  title: _propTypes2.default.string.isRequired,
  subtitle: _propTypes2.default.string.isRequired,
  description: _propTypes2.default.string
};

exports.default = DataChannelCard;