'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _identity2 = require('ramda/src/identity');

var _identity3 = _interopRequireDefault(_identity2);

var _templateObject = _taggedTemplateLiteral(['\n  padding: 8px;\n'], ['\n  padding: 8px;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _P = require('../P');

var _P2 = _interopRequireDefault(_P);

var _Small = require('../Small');

var _Small2 = _interopRequireDefault(_Small);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } /**
                                                                                                                                                   * CustomContentOfTooltip
                                                                                                                                                   * ref: http://recharts.org/#/en-US/examples/CustomContentOfTooltip
                                                                                                                                                   *
                                                                                                                                                   * @author Michael Hsu
                                                                                                                                                   */

var StyledCard = _Card2.default.extend(_templateObject);

var RechartTooltip = function RechartTooltip(_ref) {
  var active = _ref.active,
      label = _ref.label,
      payload = _ref.payload,
      formatter = _ref.formatter,
      labelFormatter = _ref.labelFormatter;

  if (!active) return null;

  return _react2.default.createElement(
    StyledCard,
    null,
    _react2.default.createElement(
      _P2.default,
      null,
      formatter(payload[0].value)
    ),
    _react2.default.createElement(
      _P2.default,
      { color: 'grayDark' },
      _react2.default.createElement(
        _Small2.default,
        null,
        labelFormatter(label)
      )
    )
  );
};

RechartTooltip.propTypes = {
  // ref: http://recharts.org/#/en-US/api/Tooltip
  active: _propTypes2.default.bool,
  label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  payload: _propTypes2.default.array, // dataPoint
  formatter: _propTypes2.default.func,
  labelFormatter: _propTypes2.default.func
};

RechartTooltip.defaultProps = {
  active: false,
  formatter: _identity3.default,
  labelFormatter: _identity3.default
};

exports.default = RechartTooltip;
module.exports = exports['default'];