'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get_time = require('date-fns/get_time');

var _get_time2 = _interopRequireDefault(_get_time);

var _set_year = require('date-fns/set_year');

var _set_year2 = _interopRequireDefault(_set_year);

var _set_month = require('date-fns/set_month');

var _set_month2 = _interopRequireDefault(_set_month);

var _set_date = require('date-fns/set_date');

var _set_date2 = _interopRequireDefault(_set_date);

var _set_hours = require('date-fns/set_hours');

var _set_hours2 = _interopRequireDefault(_set_hours);

var _set_minutes = require('date-fns/set_minutes');

var _set_minutes2 = _interopRequireDefault(_set_minutes);

var _get_year = require('date-fns/get_year');

var _get_year2 = _interopRequireDefault(_get_year);

var _get_month = require('date-fns/get_month');

var _get_month2 = _interopRequireDefault(_get_month);

var _get_date = require('date-fns/get_date');

var _get_date2 = _interopRequireDefault(_get_date);

var _get_hours = require('date-fns/get_hours');

var _get_hours2 = _interopRequireDefault(_get_hours);

var _get_minutes = require('date-fns/get_minutes');

var _get_minutes2 = _interopRequireDefault(_get_minutes);

var _end_of_month = require('date-fns/end_of_month');

var _end_of_month2 = _interopRequireDefault(_end_of_month);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DATE_API = {
  from: function from(timestamp) {
    return new Date(timestamp);
  }, // timestamp:number => Date
  to: function to(date) {
    return (0, _get_time2.default)(date);
  }, // Date => timestamp:number
  setYear: function setYear(year) {
    return function (date) {
      return (0, _set_year2.default)(date, year);
    };
  },
  setMonth: function setMonth(month) {
    return function (date) {
      return (0, _set_month2.default)(date, month);
    };
  },
  setDate: function setDate(dayOfMonth) {
    return function (date) {
      return (0, _set_date2.default)(date, dayOfMonth);
    };
  },
  setHours: function setHours(hours) {
    return function (date) {
      return (0, _set_hours2.default)(date, hours);
    };
  },
  setMinutes: function setMinutes(minutes) {
    return function (date) {
      return (0, _set_minutes2.default)(date, minutes);
    };
  },
  getYear: function getYear(date) {
    return (0, _get_year2.default)(date);
  },
  getMonth: function getMonth(date) {
    return (0, _get_month2.default)(date);
  },
  getDate: function getDate(date) {
    return (0, _get_date2.default)(date);
  },
  getHours: function getHours(date) {
    return (0, _get_hours2.default)(date);
  },
  getMinutes: function getMinutes(date) {
    return (0, _get_minutes2.default)(date);
  },
  endOfMonth: function endOfMonth(date) {
    return (0, _end_of_month2.default)(date);
  }
};

exports.default = DATE_API;
module.exports = exports['default'];