'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _inc2 = require('ramda/src/inc');

var _inc3 = _interopRequireDefault(_inc2);

var _pipe2 = require('ramda/src/pipe');

var _pipe3 = _interopRequireDefault(_pipe2);

var _range2 = require('ramda/src/range');

var _range3 = _interopRequireDefault(_range2);

var _findIndex2 = require('ramda/src/findIndex');

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _identity2 = require('ramda/src/identity');

var _identity3 = _interopRequireDefault(_identity2);

var _T2 = require('ramda/src/T');

var _T3 = _interopRequireDefault(_T2);

var _always2 = require('ramda/src/always');

var _always3 = _interopRequireDefault(_always2);

var _equals2 = require('ramda/src/equals');

var _equals3 = _interopRequireDefault(_equals2);

var _cond2 = require('ramda/src/cond');

var _cond3 = _interopRequireDefault(_cond2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Picker = require('../Picker');

var _emptyFunction = require('../utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

var _DATE_API = require('./DATE_API');

var _DATE_API2 = _interopRequireDefault(_DATE_API);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * [Timezone]
 *
 * Input: Unix Timestamp (milliseconds)
 * Output: Unix Timestamp (milliseconds)
 *
 * Internal State: Date object (local time)
 * Dislay: in local time
 *
 * @author Michael Hsu
 */

var DatetimePicker = function (_React$Component) {
  _inherits(DatetimePicker, _React$Component);

  function DatetimePicker(props) {
    _classCallCheck(this, DatetimePicker);

    var _this = _possibleConstructorReturn(this, (DatetimePicker.__proto__ || Object.getPrototypeOf(DatetimePicker)).call(this, props));

    _this.onChange = function (index, _ref) {
      var name = _ref.name;

      var newValue = _this.reducer(_this.state.value, { name: name, index: index });

      _this.setState({ value: newValue });
      _this.props.onChange(_DATE_API2.default.to(newValue)); // Remind: To Unix Timestamp (milliseconds)
    };

    _this.reducer = function (value, _ref2) {
      var name = _ref2.name,
          index = _ref2.index;
      return (0, _cond3.default)([[(0, _equals3.default)('YEAR'), (0, _always3.default)(_DATE_API2.default.setYear(_this.props.years[index]))], [(0, _equals3.default)('MONTH'), (0, _always3.default)(_DATE_API2.default.setMonth(index))], [(0, _equals3.default)('DATE'), (0, _always3.default)(_DATE_API2.default.setDate(index + 1))], [(0, _equals3.default)('HOUR'), (0, _always3.default)(_DATE_API2.default.setHours(index))], [(0, _equals3.default)('MINUTE'), (0, _always3.default)(_DATE_API2.default.setMinutes(index))], [_T3.default, _identity3.default]])(name)(value);
    };

    _this.state = {
      value: _DATE_API2.default.from(_this.props.defaultValue) // Remind: Date object
    };
    return _this;
  }

  _createClass(DatetimePicker, [{
    key: 'render',
    value: function render() {
      var years = this.props.years;
      var value = this.state.value;
      var onChange = this.onChange;


      return _react2.default.createElement(
        _Picker.PickerContainer,
        this.props,
        _react2.default.createElement(_Picker.Picker, {
          name: 'YEAR',
          value: (0, _findIndex3.default)((0, _equals3.default)(_DATE_API2.default.getYear(value)))(years),
          onChange: onChange,
          labels: years
        }),
        _react2.default.createElement(_Picker.Picker, {
          name: 'MONTH',
          value: _DATE_API2.default.getMonth(value) // 0 ~ 11
          , onChange: onChange,
          labels: _utils.MONTH_RANGE // 1 ~ 12
        }),
        _react2.default.createElement(_Picker.Picker, {
          name: 'DATE',
          value: _DATE_API2.default.getDate(value) - 1,
          onChange: onChange,
          labels: (0, _range3.default)(1, (0, _pipe3.default)(_DATE_API2.default.endOfMonth, _DATE_API2.default.getDate, _inc3.default)(value))
        }),
        _react2.default.createElement(_Picker.Picker, {
          name: 'HOUR',
          value: _DATE_API2.default.getHours(value),
          onChange: onChange,
          labels: _utils.HOUR_RANGE // 00 ~ 23
        }),
        _react2.default.createElement(_Picker.Picker, {
          name: 'MINUTE',
          value: _DATE_API2.default.getMinutes(value),
          onChange: onChange,
          labels: _utils.MINUTE_RANGE // 00 ~ 59
        })
      );
    }
  }]);

  return DatetimePicker;
}(_react2.default.Component);

DatetimePicker.propTypes = {
  defaultValue: _propTypes2.default.number.isRequired, // Unix Timestamp (milliseconds)
  onChange: _propTypes2.default.func, // (value: number) => void
  years: _propTypes2.default.array
};
DatetimePicker.defaultProps = {
  onChange: _emptyFunction2.default,
  years: [2016, 2017]
};
exports.default = DatetimePicker;
module.exports = exports['default'];