'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Overlay = undefined;

var _templateObject = _taggedTemplateLiteral(['position:fixed;top:0;bottom:0;left:0;right:0;background-color:rgba(0,0,0,0.3);display:flex;align-items:center;flex-direction:column;overflow:auto;'], ['position:fixed;top:0;bottom:0;left:0;right:0;background-color:rgba(0,0,0,0.3);display:flex;align-items:center;flex-direction:column;overflow:auto;']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Portal = require('react-overlays/lib/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _reactMotionUiPack = require('react-motion-ui-pack');

var _reactMotionUiPack2 = _interopRequireDefault(_reactMotionUiPack);

var _ClickOutside = require('react-overlay-pack/lib/ClickOutside');

var _ClickOutside2 = _interopRequireDefault(_ClickOutside);

var _emptyFunction = require('../utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Overlay = exports.Overlay = _styledComponents2.default.div(_templateObject);

var Dialog = function Dialog(_ref) {
  var onHide = _ref.onHide,
      show = _ref.show,
      children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, ['onHide', 'show', 'children']);

  return show && _react2.default.createElement(
    _Portal2.default,
    null,
    _react2.default.createElement(
      _reactMotionUiPack2.default,
      {
        component: false,
        enter: { opacity: 1 },
        leave: { opacity: 0.5 }
      },
      _react2.default.createElement(
        Overlay,
        Object.assign({ key: 'dialog' }, otherProps),
        _react2.default.createElement(
          _ClickOutside2.default,
          { onClick: onHide },
          children
        )
      )
    )
  );
};

Dialog.propTypes = {
  children: _propTypes2.default.node.isRequired,
  show: _propTypes2.default.bool.isRequired,
  onHide: _propTypes2.default.func
};
Dialog.defaultProps = {
  onHide: _emptyFunction2.default
};

exports.default = Dialog;