'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _index = require('react-overlay-pack/lib/Overlay/index');

var _index2 = _interopRequireDefault(_index);

var _styledComponents = require('./styled-components');

var _position = require('./position.config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropdownMenu = function (_React$Component) {
  _inherits(DropdownMenu, _React$Component);

  function DropdownMenu() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DropdownMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DropdownMenu.__proto__ || Object.getPrototypeOf(DropdownMenu)).call.apply(_ref, [this].concat(args))), _this), _this.state = { isOpen: false }, _this.onToggle = function () {
      return _this.setState(function () {
        return { isOpen: !_this.state.isOpen };
      });
    }, _this.onHide = function () {
      return _this.setState(function () {
        return { isOpen: false };
      });
    }, _this.onOpen = function () {
      return _this.setState(function () {
        return { isOpen: true };
      });
    }, _this.onRef = function (target) {
      _this.target = target;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DropdownMenu, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          itemRenderer = _props.itemRenderer,
          innerRef = _props.innerRef,
          position = _props.position;
      var isOpen = this.state.isOpen;
      var onToggle = this.onToggle,
          onHide = this.onHide,
          onOpen = this.onOpen,
          onRef = this.onRef,
          target = this.target;

      var renderProps = {
        isOpen: isOpen,
        close: onHide,
        open: onOpen,
        toggle: onToggle
      };

      return React.createElement(
        React.Fragment,
        null,
        React.createElement(
          'div',
          {
            ref: onRef,
            onClick: onToggle,
            onKeyPress: onToggle,
            role: 'button',
            tabIndex: '0',
            style: { display: 'inline-block' }
          },
          typeof children === 'function' ? children(renderProps) : children
        ),
        React.createElement(
          _index2.default,
          Object.assign({
            show: isOpen,
            resize: true,
            target: target,
            onOutsideClick: onHide
          }, position),
          React.createElement(
            _styledComponents.StyledMenu,
            { key: 'menu', ref: innerRef },
            itemRenderer(renderProps)
          )
        )
      );
    }
  }]);

  return DropdownMenu;
}(React.Component);

DropdownMenu.defaultProps = {
  position: _position.BOTTOM_RIGHT
};
exports.default = DropdownMenu;
module.exports = exports['default'];