'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _IconLoading = require('mcs-lite-icon/lib/IconLoading');

var _IconLoading2 = _interopRequireDefault(_IconLoading);

var _reactDndDropzone = require('react-dnd-dropzone');

var _reactDndDropzone2 = _interopRequireDefault(_reactDndDropzone);

var _P = require('../P');

var _P2 = _interopRequireDefault(_P);

var _LoadingWrapper = require('./LoadingWrapper');

var _LoadingWrapper2 = _interopRequireDefault(_LoadingWrapper);

var _Container = require('./Container');

var _Container2 = _interopRequireDefault(_Container);

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

/* eslint react/default-props-match-prop-types: 0 */
var HEIGHT = 137;

var ImageDropzone = function ImageDropzone(_ref) {
  var isLoading = _ref.isLoading,
      src = _ref.src,
      onDrop = _ref.onDrop,
      height = _ref.height,
      children = _ref.children;
  return React.createElement(_reactDndDropzone2.default, {
    onDrop: onDrop,
    render: function render(_ref2) {
      var canDrop = _ref2.canDrop;
      return React.createElement(
        _Container2.default,
        { canDrop: canDrop, src: src, height: height },
        isLoading && React.createElement(
          _LoadingWrapper2.default,
          null,
          React.createElement(_IconLoading2.default, { size: 24 })
        ),
        !src && React.createElement(
          React.Fragment,
          null,
          React.createElement(_Image2.default, { width: 50, height: 50 }),
          children && React.createElement(
            _P2.default,
            { color: 'grayBase' },
            children
          )
        )
      );
    }
  });
};

ImageDropzone.displayName = 'ImageDropzone';
ImageDropzone.propTypes = {
  isLoading: _propTypes2.default.bool,
  src: _propTypes2.default.string,
  onDrop: _propTypes2.default.func, // (file: Array<File>) => Promise<void> | void,
  height: _propTypes2.default.number,
  children: _propTypes2.default.node
};
ImageDropzone.defaultProps = {
  height: HEIGHT
};
exports.default = ImageDropzone;
module.exports = exports['default'];