'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HEIGHT = undefined;

var _omit2 = require('ramda/src/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _remove2 = require('ramda/src/remove');

var _remove3 = _interopRequireDefault(_remove2);

var _indexOf2 = require('ramda/src/indexOf');

var _indexOf3 = _interopRequireDefault(_indexOf2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _P = require('../P');

var _P2 = _interopRequireDefault(_P);

var _Orderbox = require('../Orderbox');

var _Orderbox2 = _interopRequireDefault(_Orderbox);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

var _styledComponents = require('./styled-components');

require('./type.flow');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HEIGHT = exports.HEIGHT = 192;

var InputOrder = function (_React$Component) {
  _inherits(InputOrder, _React$Component);

  function InputOrder() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, InputOrder);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = InputOrder.__proto__ || Object.getPrototypeOf(InputOrder)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function (itemValue) {
      var _this$props = _this.props,
          value = _this$props.value,
          onChange = _this$props.onChange;

      var index = (0, _indexOf3.default)(itemValue)(value);

      if (index === -1) {
        onChange([].concat(_toConsumableArray(value), [itemValue]));
      } else {
        onChange((0, _remove3.default)(index, 1)(value));
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(InputOrder, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$items = _props.items,
          items = _props$items === undefined ? [] : _props$items,
          value = _props.value,
          height = _props.height,
          placeholder = _props.placeholder,
          kind = _props.kind,
          itemRenderer = _props.itemRenderer,
          otherProps = _objectWithoutProperties(_props, ['items', 'value', 'height', 'placeholder', 'kind', 'itemRenderer']);

      var onClick = this.onClick;


      return React.createElement(
        _styledComponents.Container,
        Object.assign({ height: height }, (0, _omit3.default)(['onChange'])(otherProps)),
        items.length === 0 && placeholder && React.createElement(
          'div',
          null,
          React.createElement(
            _P2.default,
            { color: 'grayBase' },
            placeholder
          )
        ),
        items.length > 0 && items.map(function (item) {
          return React.createElement(
            _Item2.default,
            { key: item.value, value: item.value, onClick: onClick },
            React.createElement(
              _styledComponents.Center,
              null,
              React.createElement(
                _styledComponents.CheckboxWrapper,
                null,
                itemRenderer(item, { value: value, kind: kind })
              ),
              item.children
            )
          );
        })
      );
    }
  }]);

  return InputOrder;
}(React.Component);

InputOrder.defaultProps = {
  height: HEIGHT,
  kind: 'primary',
  itemRenderer: function itemRenderer(item, _ref2) {
    var value = _ref2.value,
        kind = _ref2.kind;
    return React.createElement(_Orderbox2.default, { value: (0, _indexOf3.default)(item.value)(value) + 1, kind: kind });
  }
};


InputOrder.propTypes = {
  value: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])).isRequired,
  onChange: _propTypes2.default.func.isRequired, // (value: Value) => Promise<void> | void,(value: Array<Value>) => Promise<void> | void,
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
    children: _propTypes2.default.node
  })).isRequired,
  height: _propTypes2.default.number,
  placeholder: _propTypes2.default.string,
  kind: _propTypes2.default.string,
  itemRenderer: _propTypes2.default.func // (item: ItemProps, props: any) => React.Node,
};

exports.default = InputOrder;