'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isEmpty2 = require('ramda/src/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _omit2 = require('ramda/src/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _propEq2 = require('ramda/src/propEq');

var _propEq3 = _interopRequireDefault(_propEq2);

var _findIndex2 = require('ramda/src/findIndex');

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _index = require('react-virtualized/dist/commonjs/List/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('react-virtualized/dist/commonjs/AutoSizer/index');

var _index4 = _interopRequireDefault(_index3);

var _index5 = require('react-overlay-pack/lib/ClickOutside/index');

var _index6 = _interopRequireDefault(_index5);

var _index7 = require('react-overlay-pack/lib/Transition/index');

var _index8 = _interopRequireDefault(_index7);

var _IconFold = require('mcs-lite-icon/lib/IconFold');

var _IconFold2 = _interopRequireDefault(_IconFold);

var _rafThrottle = require('raf-throttle');

var _rafThrottle2 = _interopRequireDefault(_rafThrottle);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Rotate = require('../Rotate');

var _Rotate2 = _interopRequireDefault(_Rotate);

var _MenuItem = require('../Menu/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _styledComponents2 = require('../Select/styled-components');

var _styledComponents3 = require('./styled-components');

require('./type.flow');

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global window */
/* eslint react/no-find-dom-node: 0 */


var defaultItemValueMapper = function defaultItemValueMapper(item) {
  return item.children;
};

var PureInputSelect = function (_React$Component) {
  _inherits(PureInputSelect, _React$Component);

  function PureInputSelect() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, PureInputSelect);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PureInputSelect.__proto__ || Object.getPrototypeOf(PureInputSelect)).call.apply(_ref, [this].concat(args))), _this), _this.state = { isOpen: false, filter: '', menuWidth: 0 }, _this.onOpen = function () {
      return _this.setState(function () {
        return { isOpen: true };
      });
    }, _this.onClose = function () {
      return _this.setState(function () {
        return { isOpen: false };
      });
    }, _this.onClickOutside = function (e) {
      var node = (0, _reactDom.findDOMNode)(_this.input);
      if (node && node.contains(e.target)) return; // Note: Omit input target.
      _this.onClose();
    }, _this.onToggle = function (e) {
      e.preventDefault();
      _this.setState(function (_ref2) {
        var isOpen = _ref2.isOpen;
        return { isOpen: !isOpen };
      });
    }, _this.onFilterChange = function (e) {
      var value = e.target.value;

      _this.setState(function () {
        return { filter: value };
      });
    }, _this.onInputGroupRef = function (instance) {
      // Note: for dropdown width
      _this.inputGroup = instance;
    }, _this.onInputRef = function (instance) {
      // Note: for click outside
      _this.input = instance;
    }, _this.resize = (0, _rafThrottle2.default)(function () {
      var _this2 = _this,
          inputGroup = _this2.inputGroup;

      var menuWidth = inputGroup && inputGroup.getBoundingClientRect && inputGroup.getBoundingClientRect().width;

      _this.setState(function () {
        return { menuWidth: parseInt(menuWidth, 10) };
      });
    }), _this.rowRenderer = function (_ref3) {
      var key = _ref3.key,
          index = _ref3.index,
          style = _ref3.style;
      var _this$props = _this.props,
          items = _this$props.items,
          value = _this$props.value,
          onChange = _this$props.onChange,
          _this$props$itemValue = _this$props.itemValueMapper,
          itemValueMapper = _this$props$itemValue === undefined ? defaultItemValueMapper : _this$props$itemValue;
      var filter = _this.state.filter;
      var _this3 = _this,
          onClose = _this3.onClose;

      var filteredItems = (0, _utils.filterBy)({ items: items, filter: filter, itemValueMapper: itemValueMapper });
      var item = filteredItems[index];
      var onItemClick = function onItemClick() {
        onChange(item.value);
        _this.setState(function () {
          return { filter: '' };
        });
        onClose();
      };

      return React.createElement(
        _MenuItem2.default,
        {
          key: key,
          style: style,
          active: item.value === value,
          onClick: onItemClick,
          title: itemValueMapper(item)
        },
        React.createElement(
          _styledComponents3.TextOverflow,
          null,
          item.children
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(PureInputSelect, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.resize();
      window.addEventListener('resize', this.resize);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.resize);
      if (this.resize && this.resize.cancel) this.resize.cancel();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          items = _props.items,
          kind = _props.kind,
          placeholder = _props.placeholder,
          theme = _props.theme,
          value = _props.value,
          noRowsRenderer = _props.noRowsRenderer,
          focus = _props.focus,
          menuRef = _props.menuRef,
          disableFilter = _props.disableFilter,
          _props$itemValueMappe = _props.itemValueMapper,
          itemValueMapper = _props$itemValueMappe === undefined ? defaultItemValueMapper : _props$itemValueMappe,
          otherProps = _objectWithoutProperties(_props, ['items', 'kind', 'placeholder', 'theme', 'value', 'noRowsRenderer', 'focus', 'menuRef', 'disableFilter', 'itemValueMapper']);

      var _state = this.state,
          menuWidth = _state.menuWidth,
          isOpen = _state.isOpen,
          filter = _state.filter;
      var onInputGroupRef = this.onInputGroupRef,
          onOpen = this.onOpen,
          onClose = this.onClose,
          onToggle = this.onToggle,
          onFilterChange = this.onFilterChange,
          rowRenderer = this.rowRenderer,
          onInputRef = this.onInputRef,
          onClickOutside = this.onClickOutside;


      var filteredItems = (0, _utils.filterBy)({ items: items, filter: filter, itemValueMapper: itemValueMapper });
      var activeIndex = (0, _findIndex3.default)((0, _propEq3.default)('value', value))(items);
      var activeItem = items[activeIndex];
      var menuItemHeight = (0, _utils.getMenuItemHeight)(theme);
      var menuHeight = (0, _utils.getMenuHeight)({ filteredItems: filteredItems, menuItemHeight: menuItemHeight });

      return React.createElement(
        'div',
        null,
        React.createElement(
          _styledComponents3.StyledInputGroup,
          {
            innerRef: onInputGroupRef,
            disableFilter: disableFilter
          },
          React.createElement(_Input2.default, Object.assign({
            ref: onInputRef,
            kind: kind,
            focus: focus || isOpen,
            value: (0, _utils.getInputValue)({
              isOpen: isOpen,
              filter: filter,
              activeItem: activeItem,
              itemValueMapper: itemValueMapper
            }),
            onChange: onFilterChange,
            placeholder: (0, _utils.getPlaceholder)({ isOpen: isOpen, activeItem: activeItem, placeholder: placeholder }),
            readOnly: disableFilter,
            onClick: onOpen,
            onFocus: onOpen,
            autoComplete: 'off'
          }, (0, _omit3.default)(['onChange'])(otherProps))),
          isOpen && activeItem && !filter && React.createElement(_styledComponents3.FakeInputValue, { defaultValue: itemValueMapper(activeItem) }),
          React.createElement(
            _styledComponents2.StyledButton,
            {
              kind: kind,
              active: focus || isOpen,
              square: true,
              onClick: onToggle
            },
            React.createElement(
              _Rotate2.default,
              { active: focus || isOpen },
              React.createElement(_IconFold2.default, null)
            )
          )
        ),
        isOpen && React.createElement(
          _index6.default,
          { onClick: onClickOutside },
          React.createElement(
            _index8.default,
            {
              style: { transform: 'translateY(0px)' } // From
              , animation: { translateY: 5, ease: 'easeOutQuart', duration: 350 } // To
              , component: false
            },
            React.createElement(
              _styledComponents3.StyledMenu,
              { key: 'menu', innerRef: menuRef, width: menuWidth },
              (0, _isEmpty3.default)(filteredItems) && noRowsRenderer && noRowsRenderer({ onClose: onClose }),
              React.createElement(
                _index4.default,
                { disableHeight: true },
                function (_ref4) {
                  var width = _ref4.width;
                  return React.createElement(_index2.default, {
                    width: width,
                    height: menuHeight,
                    rowCount: filteredItems.length,
                    rowHeight: menuItemHeight,
                    rowRenderer: rowRenderer,
                    scrollToIndex: activeIndex
                  });
                }
              )
            )
          )
        )
      );
    }
  }]);

  return PureInputSelect;
}(React.Component);

PureInputSelect.defaultProps = {
  kind: 'primary',
  noRowsRenderer: function noRowsRenderer() {
    return React.createElement(
      _styledComponents3.NoRowWrapper,
      null,
      'No results found'
    );
  },
  disableFilter: false,
  itemValueMapper: defaultItemValueMapper
};


var InputSelect = (0, _styledComponents.withTheme)(PureInputSelect);
InputSelect.displayName = 'InputSelect';
InputSelect.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]).isRequired,
  onChange: _propTypes2.default.func.isRequired, // (value: Value) => Promise<void> | void,
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]).isRequired,
    children: _propTypes2.default.node.isRequired
  })).isRequired,
  kind: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  noRowsRenderer: _propTypes2.default.func,
  focus: _propTypes2.default.bool,
  disableFilter: _propTypes2.default.bool,
  itemValueMapper: _propTypes2.default.func,
  menuRef: _propTypes2.default.func
};

exports.default = InputSelect;
module.exports = exports['default'];