'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MAX_HEIGHT = undefined;

var _length2 = require('ramda/src/length');

var _length3 = _interopRequireDefault(_length2);

exports.filterBy = filterBy;
exports.getInputValue = getInputValue;
exports.getPlaceholder = getPlaceholder;
exports.getMenuItemHeight = getMenuItemHeight;
exports.getMenuHeight = getMenuHeight;

require('./type.flow');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MAX_HEIGHT = exports.MAX_HEIGHT = 155;
function filterBy(_ref) {
  var items = _ref.items,
      filter = _ref.filter,
      itemValueMapper = _ref.itemValueMapper;

  var regex = new RegExp(filter, 'gi');
  return items.filter(function (item) {
    return regex.test(itemValueMapper(item));
  });
}

function getInputValue(_ref2) {
  var isOpen = _ref2.isOpen,
      filter = _ref2.filter,
      activeItem = _ref2.activeItem,
      itemValueMapper = _ref2.itemValueMapper;

  var value = void 0;

  if (isOpen) {
    value = filter;
  } else {
    value = activeItem ? itemValueMapper(activeItem) : '';
  }

  return value;
}

function getPlaceholder(_ref3) {
  var isOpen = _ref3.isOpen,
      activeItem = _ref3.activeItem,
      placeholder = _ref3.placeholder;

  if (isOpen && activeItem) return '';

  return placeholder || '';
}

function getMenuItemHeight(theme) {
  return parseInt(theme.height.normal.replace('px', ''), 10);
}

function getMenuHeight(_ref4) {
  var filteredItems = _ref4.filteredItems,
      menuItemHeight = _ref4.menuItemHeight;

  var length = (0, _length3.default)(filteredItems);

  return length < 5 ? menuItemHeight * length : MAX_HEIGHT;
}