'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContentWrapper = exports.ImageWrapper = exports.StyledCard = undefined;

var _templateObject = _taggedTemplateLiteral(['\n  height: 120px;\n  display: flex;\n'], ['\n  height: 120px;\n  display: flex;\n']),
    _templateObject2 = _taggedTemplateLiteral(['flex-grow:2;'], ['flex-grow:2;']),
    _templateObject3 = _taggedTemplateLiteral(['flex-grow:1;flex-basis:0;padding:8px;'], ['flex-grow:1;flex-basis:0;padding:8px;']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactTextTruncate = require('react-text-truncate');

var _reactTextTruncate2 = _interopRequireDefault(_reactTextTruncate);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _Img = require('../Img');

var _Img2 = _interopRequireDefault(_Img);

var _Heading = require('../Heading');

var _Heading2 = _interopRequireDefault(_Heading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var StyledCard = exports.StyledCard = _Card2.default.extend(_templateObject);

var ImageWrapper = exports.ImageWrapper = _styledComponents2.default.div(_templateObject2);

var ContentWrapper = exports.ContentWrapper = _styledComponents2.default.div(_templateObject3);

var MobileDeviceCard = function MobileDeviceCard(_ref) {
  var title = _ref.title,
      image = _ref.image,
      otherProps = _objectWithoutProperties(_ref, ['title', 'image']);

  return _react2.default.createElement(
    StyledCard,
    otherProps,
    _react2.default.createElement(
      ImageWrapper,
      null,
      _react2.default.createElement(_Img2.default, { src: image })
    ),
    _react2.default.createElement(
      ContentWrapper,
      null,
      _react2.default.createElement(
        _Heading2.default,
        { level: 4, color: 'black' },
        _react2.default.createElement(_reactTextTruncate2.default, { line: 4, truncateText: ' ...', text: title })
      )
    )
  );
};

MobileDeviceCard.displayName = 'MobileDeviceCard';
MobileDeviceCard.propTypes = {
  title: _propTypes2.default.string.isRequired,
  image: _propTypes2.default.string.isRequired
};

exports.default = MobileDeviceCard;