'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledHeading = exports.Right = exports.Center = exports.Left = exports.Wrapper = exports.Fixed = exports.Container = undefined;

var _templateObject = _taggedTemplateLiteral(['height:', ';'], ['height:', ';']),
    _templateObject2 = _taggedTemplateLiteral(['position:fixed;top:0;left:0;right:0;background-color:', ';height:', ';box-shadow:0 1px 5px 0 rgba(0,0,0,0.3);'], ['position:fixed;top:0;left:0;right:0;background-color:', ';height:', ';box-shadow:0 1px 5px 0 rgba(0,0,0,0.3);']),
    _templateObject3 = _taggedTemplateLiteral(['display:flex;align-items:center;justify-content:space-between;'], ['display:flex;align-items:center;justify-content:space-between;']),
    _templateObject4 = _taggedTemplateLiteral(['display:flex;height:100%;align-items:center;overflow:hidden;flex-shrink:0;'], ['display:flex;height:100%;align-items:center;overflow:hidden;flex-shrink:0;']),
    _templateObject5 = _taggedTemplateLiteral(['display:flex;height:100%;align-items:center;flex-grow:1;overflow:hidden;'], ['display:flex;height:100%;align-items:center;flex-grow:1;overflow:hidden;']),
    _templateObject6 = _taggedTemplateLiteral(['display:flex;height:100%;align-items:center;flex-grow:1;justify-content:flex-end;'], ['display:flex;height:100%;align-items:center;flex-grow:1;justify-content:flex-end;']),
    _templateObject7 = _taggedTemplateLiteral(['user-select:none;width:100%;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;'], ['user-select:none;width:100%;white-space:nowrap;text-overflow:ellipsis;overflow:hidden;']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Portal = require('react-overlays/lib/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _MobileContentWrapper = require('../MobileContentWrapper');

var _MobileContentWrapper2 = _interopRequireDefault(_MobileContentWrapper);

var _Heading = require('../Heading');

var _Heading2 = _interopRequireDefault(_Heading);

var _B = require('../B');

var _B2 = _interopRequireDefault(_B);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Container = exports.Container = _styledComponents2.default.header(_templateObject, function (props) {
  return props.theme.mobile.headerHeight;
});

var Fixed = exports.Fixed = _styledComponents2.default.div(_templateObject2, function (props) {
  return props.theme.color.primary;
}, function (props) {
  return props.theme.mobile.headerHeight;
});

var Wrapper = exports.Wrapper = (0, _styledComponents2.default)(_MobileContentWrapper2.default)(_templateObject3);

var Left = exports.Left = _styledComponents2.default.div(_templateObject4);

var Center = exports.Center = _styledComponents2.default.div(_templateObject5);

var Right = exports.Right = _styledComponents2.default.div(_templateObject6);

var StyledHeading = exports.StyledHeading = (0, _styledComponents2.default)(_Heading2.default)(_templateObject7);

var MobileHeader = function MobileHeader(_ref) {
  var title = _ref.title,
      leftChildren = _ref.leftChildren,
      rightChildren = _ref.rightChildren,
      otherProps = _objectWithoutProperties(_ref, ['title', 'leftChildren', 'rightChildren']);

  return _react2.default.createElement(
    Container,
    otherProps,
    _react2.default.createElement(
      _Portal2.default,
      null,
      _react2.default.createElement(
        Fixed,
        null,
        _react2.default.createElement(
          Wrapper,
          null,
          _react2.default.createElement(
            Left,
            null,
            leftChildren
          ),
          title && _react2.default.createElement(
            Center,
            null,
            _react2.default.createElement(
              StyledHeading,
              { level: 3, color: 'white' },
              _react2.default.createElement(
                _B2.default,
                null,
                title
              )
            )
          ),
          _react2.default.createElement(
            Right,
            null,
            rightChildren
          )
        )
      )
    )
  );
};

MobileHeader.displayName = 'MobileHeader';
MobileHeader.propTypes = {
  title: _propTypes2.default.string,
  leftChildren: _propTypes2.default.node.isRequired,
  rightChildren: _propTypes2.default.node
};

exports.default = MobileHeader;