'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Item = exports.ItemWrapper = undefined;

var _divide2 = require('ramda/src/divide');

var _divide3 = _interopRequireDefault(_divide2);

var _2 = require('ramda/src/__');

var _3 = _interopRequireDefault(_2);

var _subtract2 = require('ramda/src/subtract');

var _subtract3 = _interopRequireDefault(_subtract2);

var _negate2 = require('ramda/src/negate');

var _negate3 = _interopRequireDefault(_negate2);

var _multiply2 = require('ramda/src/multiply');

var _multiply3 = _interopRequireDefault(_multiply2);

var _pipe2 = require('ramda/src/pipe');

var _pipe3 = _interopRequireDefault(_pipe2);

var _clamp2 = require('ramda/src/clamp');

var _clamp3 = _interopRequireDefault(_clamp2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['padding-top:', 'px;'], ['padding-top:', 'px;']),
    _templateObject2 = _taggedTemplateLiteral(['display:flex;align-items:center;justify-content:center;height:', 'px;user-select:none;color:', ';'], ['display:flex;align-items:center;justify-content:center;height:', 'px;user-select:none;color:', ';']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactHammerjs = require('../utils/react-hammerjs');

var _reactHammerjs2 = _interopRequireDefault(_reactHammerjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } /* eslint no-underscore-dangle: 0 */

var CONTAINER_HEIGHT = 200;
var ITEM_HEIGHT = 40;

var ItemWrapper = exports.ItemWrapper = _styledComponents2.default.div(_templateObject, CONTAINER_HEIGHT / 2 - ITEM_HEIGHT / 2);

var Item = exports.Item = _styledComponents2.default.div(_templateObject2, ITEM_HEIGHT, function (props) {
  return props.active ? props.theme.color.black : props.theme.color.grayBase;
});

var Picker = function (_React$Component) {
  _inherits(Picker, _React$Component);

  function Picker(props) {
    _classCallCheck(this, Picker);

    var _this = _possibleConstructorReturn(this, (Picker.__proto__ || Object.getPrototypeOf(Picker)).call(this, props));

    _this.onPanVerticalStart = function () {
      _this.fromY = 0;
      _this.toY = _this.fromY;
      _this.last = _this.state.distance;
    };

    _this.onPanVertical = function (e) {
      _this.toY = e.deltaY;
      _this.setState({ distance: _this.last + (_this.toY - _this.fromY) });
      e.preventDefault();
    };

    _this.onPanVerticalEnd = function () {
      if (_this.props.onChange) {
        // TODO: consider velocity for animation
        // continueDistance = e.velocityY * e.velocityY * 100;
        var index = _this.calcIndexByDistance(_this.state.distance);
        _this.props.onChange(index, _this.props);
      } else {
        // Hint: Make it as control component - back to origin position.
        _this.setState({
          distance: _this.calcDistanceByIndex(_this.props.value)
        });
      }
    };

    _this.clampIndex = function (index) {
      return (0, _clamp3.default)(0, _this.props.labels.length - 1)(index);
    };

    _this.calcDistanceByIndex = (0, _pipe3.default)(_this.clampIndex, (0, _multiply3.default)(ITEM_HEIGHT), _negate3.default);
    _this.calcIndexByDistance = (0, _pipe3.default)((0, _subtract3.default)(_3.default, ITEM_HEIGHT / 2), Math.abs, (0, _divide3.default)(_3.default, ITEM_HEIGHT), Math.ceil, (0, _subtract3.default)(_3.default, 1), // Remind: convert to index, start from 0.
    _this.clampIndex);

    _this.state = { distance: _this.calcDistanceByIndex(props.value) };
    return _this;
  }

  _createClass(Picker, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ distance: this.calcDistanceByIndex(nextProps.value) });
    }

    // Important: need arrow function to get this object.


    /**
     * Calculating the position.
     * (index: number) => distance: number
     *
     * @author Michael Hsu
     */


    /**
     * Calculating the active index.
     * (distance: number) => index: number
     *
     * @author Michael Hsu
     */

  }, {
    key: 'render',
    value: function render() {
      var labels = this.props.labels;
      var distance = this.state.distance;
      var calcIndexByDistance = this.calcIndexByDistance;


      return _react2.default.createElement(
        _reactHammerjs2.default,
        {
          onPan: this.onPanVertical,
          onPanStart: this.onPanVerticalStart,
          onPanEnd: this.onPanVerticalEnd,
          direction: 'DIRECTION_VERTICAL',
          options: { touchAction: 'pan-x' }
        },
        _react2.default.createElement(
          ItemWrapper,
          { style: { marginTop: distance } },
          labels.map(function (label, index) {
            return _react2.default.createElement(
              Item,
              { key: label, active: calcIndexByDistance(distance) === index },
              label
            );
          })
        )
      );
    }
  }]);

  return Picker;
}(_react2.default.Component);

Picker.propTypes = {
  value: _propTypes2.default.number, // index
  onChange: _propTypes2.default.func, // (index: number, props: object) => void
  labels: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])).isRequired
};
Picker.defaultProps = {
  value: 0
};
exports.default = Picker;