'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoadingContainer = exports.PullWrapper = undefined;

var _IconGoDown2 = require('mcs-lite-icon/lib/IconGoDown');

var _IconGoDown3 = _interopRequireDefault(_IconGoDown2);

var _IconLoading2 = require('mcs-lite-icon/lib/IconLoading');

var _IconLoading3 = _interopRequireDefault(_IconLoading2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['transition:', ';'], ['transition:', ';']),
    _templateObject2 = _taggedTemplateLiteral(['margin-top:-', 'px;height:', 'px;display:flex;align-items:center;justify-content:center;> *{transition:all 0.25s ease;transform:', ';}'], ['margin-top:-', 'px;height:', 'px;display:flex;align-items:center;justify-content:center;> *{transition:all 0.25s ease;transform:', ';}']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactHammerjs = require('../utils/react-hammerjs');

var _reactHammerjs2 = _interopRequireDefault(_reactHammerjs);

var _Heading = require('../Heading');

var _Heading2 = _interopRequireDefault(_Heading);

var _Spin = require('../Spin');

var _Spin2 = _interopRequireDefault(_Spin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } /* global document */
// Ref: https://github.com/renatn/react-pull-to-refresh/blob/master/PullToRefresh.jsx

var HEIGHT = 60;
var SENSITIVITY = 2;

var PullWrapper = exports.PullWrapper = _styledComponents2.default.div(_templateObject, function (props) {
  return props.distance === 0 || props.isLoading ? 'all .25s ease' : 'initial';
});

var LoadingContainer = exports.LoadingContainer = _styledComponents2.default.div(_templateObject2, HEIGHT, HEIGHT, function (props) {
  return props.distance >= HEIGHT ? 'rotate(180deg)' : 'initial';
});

var PullToRefresh = function (_React$Component) {
  _inherits(PullToRefresh, _React$Component);

  function PullToRefresh(props) {
    _classCallCheck(this, PullToRefresh);

    var _this = _possibleConstructorReturn(this, (PullToRefresh.__proto__ || Object.getPrototypeOf(PullToRefresh)).call(this, props));

    _this.onPanDownStart = function () {
      _this.fromY = 0;
      _this.toY = _this.fromY;
    };

    _this.onPanDown = function (e) {
      if (document.body.scrollTop > 0) return; // Remind: Skip the event if it's not pulled from top.
      if (_this.props.isLoading) {
        e.preventDefault(); // Hint: Prevent being pulled while refreshing.
        return;
      }
      e.preventDefault();

      _this.toY = e.deltaY;
      _this.setState({ distance: (_this.toY - _this.fromY) / SENSITIVITY });
    };

    _this.onPanDownEnd = function () {
      if (_this.props.isLoading) return; // Remind: Prevent re-refreshing.

      // Remind: Trigger only when it is pulled heigher than HEIGHT.
      if (_this.state.distance < HEIGHT) {
        _this.reset();
        return;
      }

      _this.setLoading();
      _this.props.onPull();
    };

    _this.setLoading = function () {
      return _this.setState({ distance: HEIGHT });
    };

    _this.reset = function () {
      return _this.setState({ distance: 0 });
    };

    _this.state = { distance: props.isLoading ? HEIGHT : 0 };
    return _this;
  }

  _createClass(PullToRefresh, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.isLoading) return this.setLoading();

      return this.reset();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          isLoading = _props.isLoading,
          IconArrow = _props.IconArrow,
          IconLoading = _props.IconLoading,
          otherProps = _objectWithoutProperties(_props, ['children', 'isLoading', 'IconArrow', 'IconLoading']);

      var distance = this.state.distance;


      return _react2.default.createElement(
        _reactHammerjs2.default,
        {
          onPan: this.onPanDown,
          onPanStart: this.onPanDownStart,
          onPanEnd: this.onPanDownEnd,
          direction: 'DIRECTION_DOWN',
          options: { touchAction: 'pan-x pan-y' }
        },
        _react2.default.createElement(
          PullWrapper,
          Object.assign({}, otherProps, {
            distance: distance,
            isLoading: isLoading,
            style: { marginTop: distance }
          }),
          _react2.default.createElement(
            LoadingContainer,
            { distance: distance },
            isLoading ? IconLoading : IconArrow
          ),
          children
        )
      );
    }
  }]);

  return PullToRefresh;
}(_react2.default.Component);

PullToRefresh.propTypes = {
  children: _propTypes2.default.node.isRequired,
  isLoading: _propTypes2.default.bool.isRequired,
  onPull: _propTypes2.default.func.isRequired,
  IconArrow: _propTypes2.default.node,
  IconLoading: _propTypes2.default.node
};
PullToRefresh.defaultProps = {
  IconLoading: _react2.default.createElement(
    _Heading2.default,
    { level: 2, color: 'grayDark' },
    _react2.default.createElement(
      _Spin2.default,
      null,
      _react2.default.createElement(_IconLoading3.default, null)
    )
  ),
  IconArrow: _react2.default.createElement(
    _Heading2.default,
    { level: 2, color: 'grayDark' },
    _react2.default.createElement(_IconGoDown3.default, null)
  )
};
exports.default = PullToRefresh;