'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _omit2 = require('ramda/src/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _propEq2 = require('ramda/src/propEq');

var _propEq3 = _interopRequireDefault(_propEq2);

var _find2 = require('ramda/src/find');

var _find3 = _interopRequireDefault(_find2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _IconFold = require('mcs-lite-icon/lib/IconFold');

var _IconFold2 = _interopRequireDefault(_IconFold);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Rotate = require('../Rotate');

var _Rotate2 = _interopRequireDefault(_Rotate);

var _styledComponents = require('./styled-components');

require('./type.flow');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PLACEHOLDER_VALUE = 'SELECT/PLACEHOLDER_VALUE';

var Select = function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = { isOpen: false }, _this.onFocus = function () {
      return _this.setState({ isOpen: true });
    }, _this.onBlur = function () {
      return _this.setState({ isOpen: false });
    }, _this.valueMapper = function (value) {
      var items = _this.props.items;

      var selectedItem = (0, _find3.default)((0, _propEq3.default)('value', value))(items);
      return selectedItem && selectedItem.children || '';
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Select, [{
    key: 'render',
    value: function render() {
      var isOpen = this.state.isOpen;

      var _props = this.props,
          focus = _props.focus,
          items = _props.items,
          kind = _props.kind,
          value = _props.value,
          placeholder = _props.placeholder,
          otherProps = _objectWithoutProperties(_props, ['focus', 'items', 'kind', 'value', 'placeholder']);

      var onFocus = this.onFocus,
          onBlur = this.onBlur,
          valueMapper = this.valueMapper;

      return React.createElement(
        _styledComponents.Wrapper,
        null,
        React.createElement(
          _styledComponents.StyledInputGroup,
          null,
          React.createElement(_Input2.default, Object.assign({
            kind: kind,
            value: valueMapper(value),
            placeholder: placeholder,
            readOnly: true,
            focus: focus || isOpen
          }, (0, _omit3.default)(['onChange'])(otherProps))),
          React.createElement(
            _styledComponents.StyledButton,
            { kind: kind, active: focus || isOpen, square: true },
            React.createElement(
              _Rotate2.default,
              { active: focus || isOpen },
              React.createElement(_IconFold2.default, null)
            )
          )
        ),
        React.createElement(
          _styledComponents.StyledSelect,
          Object.assign({
            value: value || PLACEHOLDER_VALUE
          }, otherProps, {
            onFocus: onFocus,
            onBlur: onBlur
          }),
          placeholder && React.createElement(
            'option',
            { value: PLACEHOLDER_VALUE, disabled: true },
            placeholder
          ),
          items.map(function (e) {
            return React.createElement('option', Object.assign({ key: e.value }, e));
          })
        )
      );
    }
  }]);

  return Select;
}(React.Component);

Select.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    children: _propTypes2.default.string.isRequired,
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired
  })).isRequired,
  kind: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  focus: _propTypes2.default.bool
};
Select.defaultProps = {
  kind: 'primary',
  value: ''
};
exports.default = Select;
module.exports = exports['default'];