'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledP = exports.StyledCard = undefined;

var _T2 = require('ramda/src/T');

var _T3 = _interopRequireDefault(_T2);

var _path2 = require('ramda/src/path');

var _path3 = _interopRequireDefault(_path2);

var _propEq2 = require('ramda/src/propEq');

var _propEq3 = _interopRequireDefault(_propEq2);

var _cond2 = require('ramda/src/cond');

var _cond3 = _interopRequireDefault(_cond2);

var _templateObject = _taggedTemplateLiteral(['\n  border: 1px solid ', ';\n  background-color: rgba(255, 255, 255, 0.9);\n'], ['\n  border: 1px solid ', ';\n  background-color: rgba(255, 255, 255, 0.9);\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  display: flex;\n  align-items: center;\n  padding: 10px 20px;\n  color: ', ';\n  background-color: ', ';\n'], ['\n  display: flex;\n  align-items: center;\n  padding: 10px 20px;\n  color: ', ';\n  background-color: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mcsLiteTheme = require('mcs-lite-theme');

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _P = require('../P');

var _P2 = _interopRequireDefault(_P);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var lighten = (0, _mcsLiteTheme.opacity)(0.1);

var mapColorByKind = (0, _cond3.default)([[(0, _propEq3.default)('kind', 'default'), (0, _path3.default)(['theme', 'color', 'grayDark'])], [_T3.default, function (props) {
  return (0, _path3.default)(['theme', 'color', props.kind]);
}]]);

var StyledCard = exports.StyledCard = _Card2.default.extend(_templateObject, mapColorByKind);

var StyledP = exports.StyledP = _P2.default.extend(_templateObject2, mapColorByKind, function (props) {
  return lighten(props.theme.color[props.kind]);
});

var Toast = function Toast(_ref) {
  var children = _ref.children,
      kind = _ref.kind,
      otherProps = _objectWithoutProperties(_ref, ['children', 'kind']);

  return _react2.default.createElement(
    StyledCard,
    Object.assign({}, otherProps, { kind: kind }),
    _react2.default.createElement(
      StyledP,
      { kind: kind },
      children
    )
  );
};

Toast.displayName = 'Toast';
Toast.propTypes = {
  children: _propTypes2.default.node.isRequired,
  kind: _propTypes2.default.string
};
Toast.defaultProps = {
  kind: 'primary'
};

exports.default = Toast;