'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactCookie = require('react-cookie');

var _reactCookie2 = _interopRequireDefault(_reactCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Never access cookie something like below or you will get old cookie object.
 *
 * [X] .mapTo(cookie.load('token'));
 * [O] .map(() => cookie.load('token'));
 *
 * @author Michael Hsu
 */

var getCookieToken = function getCookieToken() {
  return _reactCookie2.default.load('token');
};
var removeCookieToken = function removeCookieToken() {
  return _reactCookie2.default.remove('token', { path: '/' });
};

exports.default = {
  getCookieToken: getCookieToken,
  removeCookieToken: removeCookieToken
};
module.exports = exports['default'];