"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * For react-router 3.X <Link /> 'to' property
 * ref: https://github.com/ReactTraining/react-router/blob/master/docs/API.md#props-1
 *
 * // Function returning location descriptor.
 * <Link to={location => ({ ...location, query: { name: 'ryan' } })}>
 *   Hello
 * </Link>
 *
 * @author Michael Hsu
 */

var updatePathname = exports.updatePathname = function updatePathname(pathname) {
  return function (location) {
    var locale = location.query.locale;

    return { pathname: pathname, query: _extends({}, location.query, { locale: locale }) };
  };
};

var updateLocale = exports.updateLocale = function updateLocale(locale) {
  return function (location) {
    var pathname = location.pathname;

    return { pathname: pathname, query: _extends({}, location.query, { locale: locale }) };
  };
};